"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const helpers_1 = require("./helpers");
exports.default = {
    run(result, dep, options) {
        const usedMethods = (0, helpers_1.getUsedMethods)(options.sourceCode, dep.name);
        result.declarations.push({
            name: options.variableName,
            type: `jasmine.SpyObj<${dep.type || 'any'}>`
        });
        if (usedMethods.length > 0) {
            result.initializers.push({
                name: options.variableName,
                value: `jasmine.createSpyObj<${dep.type || 'any'}>(${options.quoteSymbol}${dep.type === 'any' || !dep.type ? dep.name : dep.type}${options.quoteSymbol}, [${usedMethods.map(m => (options.quoteSymbol + m + options.quoteSymbol)).join(`, `)}])`
            });
        }
        else {
            result.initializers.push({
                name: options.variableName,
                value: `{} as jasmine.SpyObj<${dep.type || 'any'}>`
            });
        }
        result.dependencies.push({
            name: options.variableName,
            token: options.injectionToken || 'no-token'
        });
    },
    test(_dep) {
        return true;
    }
};
